<?PHP
/**********************************************************************
File Name:              index.php
Dev:                    Daniele De Santis
Email:                  webmaster@desantix.it
Web:                    http://www.desantix.it

Versione:               0.7
Data:                   27/11/14
Note Hardware:  
Note Software:          PHP 5
**********************************************************************/
@date_default_timezone_set('Europe/Rome');

include "inverter_label.inc.php";
include "setup.php";

define ("DEBUG_ON", 0);

$_APP_NAME = "INVERTER PowerMeterLite";
$_APP_VER  = "0.7 beta";


$server_ip = $_REQUEST[IP];
if(empty($server_ip))
  $server_ip = $default_ip;

$server_port = $_REQUEST[PORT];
if(empty($server_port))
  $server_port = $default_port;

$inverter_address = $_REQUEST[ADR];
if(empty($inverter_address))
  $inverter_address = $default_address;

if(!empty($_REQUEST[INCENTIVO]))
  $incentivo = $_REQUEST[INCENTIVO];
  
  
$CMD_SN    = chr($inverter_address) . chr(0x3f) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_ST    = chr($inverter_address) . chr(0x32) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_CET   = chr($inverter_address) . chr(0x4e) . chr(0x05) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_CED   = chr($inverter_address) . chr(0x4e) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);
$CMD_DSP1  = chr($inverter_address) . chr(0x3b) . chr(0x01) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Grid VOLT
$CMD_DSP4=  chr($inverter_address) . chr(0x3b) . chr(0x04) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00); //DSP Frequency
$CMD_DSP3  = chr($inverter_address) . chr(0x3b) . chr(0x03) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Grid Power
$CMD_DSP23 = chr($inverter_address) . chr(0x3b) . chr(0x17) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 1 Voltage
$CMD_DSP25 = chr($inverter_address) . chr(0x3b) . chr(0x19) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 1 Current
$CMD_DSP26 = chr($inverter_address) . chr(0x3b) . chr(0x1A) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 2 Voltage
$CMD_DSP27 = chr($inverter_address) . chr(0x3b) . chr(0x1B) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP Input 2 Current
$CMD_DSP7  = chr($inverter_address) . chr(0x3b) . chr(0x07) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//Ileak
$CMD_DSP8  = chr($inverter_address) . chr(0x3b) . chr(0x08) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP PIN1
$CMD_DSP9  = chr($inverter_address) . chr(0x3b) . chr(0x09) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//DSP PIN2
$CMD_DSP30 = chr($inverter_address) . chr(0x3b) . chr(0x1E) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//R iso (bug ris 0.7)
$CMD_DSP15 = chr($inverter_address) . chr(0x3b) . chr(0x15) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//T CPU
$CMD_DSP16 = chr($inverter_address) . chr(0x3b) . chr(0x16) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);//T IGBT
$CMD_VR    = chr($inverter_address) . chr(0x3A) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00) . chr(0x00);

$cmdarray= array("ST"=>$CMD_ST, "CET"=>$CMD_CET, "CED"=>$CMD_CED,"DSP1"=>$CMD_DSP1,"DSP3"=>$CMD_DSP3,"DSP4"=>$CMD_DSP4,"DSP7"=>$CMD_DSP7,"DSP8"=>$CMD_DSP8,"DSP9"=>$CMD_DSP9,"DSP15"=>$CMD_DSP15,"DSP16"=>$CMD_DSP16,"DSP23"=>$CMD_DSP23,"DSP25"=>$CMD_DSP25,"DSP26"=>$CMD_DSP26,"DSP27"=>$CMD_DSP27,"DSP30"=>$CMD_DSP30,"SN"=>$CMD_SN,"VR"=>$CMD_VR);


function PrintHEX($cmd){
  for ($x=0; $x<strlen($cmd); $x++)
    printf("0x%x ", ord($cmd[$x]));
  print "<br>";
}

function HexToChar($Hex){
  $string="";
  for ($i=0; $i<(strlen($Hex)); $i++) 
    $string .= chr(ord($Hex[$i]));
  return $string;
}

function DSPValue($Hex){
  $v = (ord($Hex[2])<<24) + (ord($Hex[3])<<16) + (ord($Hex[4])<<8) + ord($Hex[5]);
  $x = ($v & ((1 << 23) - 1)) + (1 << 23) * ($v >> 31 | 1);
  $exp = ($v >> 23 & 0xFF) - 127;
  return $x * pow(2, $exp - 23);
}

function CRC($cmd){
  $BccLo=0xFF;
  $BccHi=0xFF;
  for ( $x=0; $x<strlen($cmd); $x++ ) {
    $c = ord($cmd[$x]) ^ $BccLo;
    $tmp=($c << 4) & 0xFF;
    $c=$tmp ^ $c;
    $tmp=($c >> 5) & 0xFF; 
    $BccLo=$BccHi;
    $BccHi= $c ^ $tmp;
    $tmp= ($c << 3) & 0xFF;
    $BccLo= $BccLo ^ $tmp;
    $tmp= ($c >> 4) & 0xFF;
    $BccLo= $BccLo ^ $tmp;
  }
  $CRC_L=~($BccLo) & 0xFF;
  $CRC_H=~($BccHi)& 0xFF;
  return (($CRC_H<<8) & 0xFF00) + (($CRC_L)& 0xFF);
}

function CheckCRC($rxdata){
  $rx_crc = $rxdata[6].$rxdata[7];
  $my_crc=CRC(substr($rxdata, 0, -2));
  $my_crc=chr(($my_crc & 0xFF)) . chr((($my_crc>>8) & 0xFF));
  if((ord($rx_crc[0])==ord($my_crc[0])) && (ord($rx_crc[1])==ord($my_crc[1]))) return 1;
  return 0;
}

function QueryInverter($server_ip, $server_port, $cmdarray){
  $cmd_crc=CRC($cmd);
  $cmd  = $cmd . chr(($cmd_crc & 0xFF)) . chr((($cmd_crc>>8) & 0xFF)); #Appendo il CRC
  $fp   = @fsockopen($server_ip, $server_port, $errno, $errstr, 10);
  if (!$fp) return 1;
  if(DEBUG_ON){
    echo "Connessione TCP/IP OK<br>";
  }
  $error=10;
  foreach ($cmdarray as $key => $value) {
    $cmd_crc=CRC($value);
    $txcmd= $value . chr(($cmd_crc & 0xFF)) . chr((($cmd_crc>>8) & 0xFF)); #Appendo il CRC
    if(DEBUG_ON){
      echo "TX->";
      PrintHEX($txcmd);
      echo "<br>";
    }
    fputs($fp, $txcmd, 10);
    $rxbuff=fread ($fp,8);
    if(DEBUG_ON){
      echo "RX<-";
      PrintHEX($rxbuff);
      echo "<br>";
    }
    if(strlen($rxbuff)==8){
      $$key="";
      if(CheckCRC($rxbuff)){
        global $$key;
        $rxbuff=substr($rxbuff, 0, -2);
        $$key=$rxbuff;
        $error=0;
      } else $$key="0"; //Crc Errato
    } else 
      break;
  }
  fclose($fp);
  return $error;
}


//INTESTAZIONE
echo"<html>";
echo"<title>$_APP_NAME</title>";
echo"<link href=\"./style.css\" rel=\"stylesheet\" type=\"text/css\">";
echo"<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no\">";
if(!empty($server_ip)) echo"<meta http-equiv=\"refresh\" content=\"60\">";
echo"</head>";
echo"<body>";
echo "<div id=\"header\"><img src='images/logo.png'></div>";
//Form se non  presente alcun indirizzo IP
if(empty($server_ip)){
  echo"<form method=post action=\"./\">";
  echo"<table width=100% cellspacing=0 cellpadding=0 border=0>";
  echo"<tr><td class=listr align=right width=50%>Indirizzo IP</td><td class=listbg width=50%><input type=text size=15 maxlenght=50 name=IP></td></tr>";
  echo"<tr><td class=listr align=right>Porta</td><td class=listbg><input type=text size=15 maxlenght=5 name=PORT value=\"$default_port\"></td></tr>";
  echo"<tr><td class=listr align=right>Indirizzo Inverter</td><td class=listbg><select name=ADR>";
  for ($i=1; $i<13; $i++) {
    $tmp = sprintf("0x%02d", $i);
    if($tmp==$default_address)
      printf("<option value=$tmp selected>$tmp</option>");
    else 
      printf("<option value=$tmp>$tmp</option>");
  }
  echo"</select></td></tr>";
  echo"<tr><td class=listr align=right>Incentivo</td><td class=listbg><input type=text size=15 maxlenght=10 name=INCENTIVO value=\"0\"></td></tr>";
  echo"<tr><td class=listr align=right>&nbsp;</td><td class=listbg><input type=submit value=\"  Interroga  \"></td></tr>";
  echo"<table>";
  echo"</form>";
} else {
  $res=QueryInverter($server_ip, $server_port, $cmdarray);
  if($res==0){
    $Version        = $VersionPart1_Label[substr($VR, 2, 1)];
    $GlobalState    = ord($ST[1]); #bug ris 0.7
    $InverterState  = ord($ST[2]);
    $AlarmState     = ord($ST[5]);
    $AlarmCODE = $AlarmState_Label[$AlarmState][1];
    if(strlen($AlarmCODE)) $AlarmCODE = "(CODE: " . $AlarmCODE . ")";
    $CET   = (ord($CET[2])<<24) + (ord($CET[3])<<16) + (ord($CET[4])<<8) + ord($CET[5]);
    $CET   = ((float)$CET /1000);
    $CED   = (ord($CED[2])<<24) + (ord($CED[3])<<16) + (ord($CED[4])<<8) + ord($CED[5]);
    $CED   = ((float)$CED /1000);
    $DSP3  = DSPValue($DSP3);
    $DSP4  = DSPValue($DSP4);
    $DSP7  = DSPValue($DSP7)*1000;
    $DSP1  = DSPValue($DSP1);
    $DSP8  = DSPValue($DSP8);
    $DSP9  = DSPValue($DSP9);
    $DSP23 = DSPValue($DSP23);
    $DSP25 = DSPValue($DSP25);
    $DSP26 = DSPValue($DSP26);
    $DSP27 = DSPValue($DSP27);
    $DSP30 = DSPValue($DSP30);
    $DSP15 = DSPValue($DSP15);
    $DSP16 = DSPValue($DSP16);
    $PIN   = ($DSP8+$DSP9);
    echo"<table width=100% cellspacing=0 cellpadding=0 border=0>";
    printf("<tr><td class=listr colspan=2 >Aggiornamento</td><td class=listbg colspan=2> <b>" . date('H:i:s d/m/y'). "</b></td></tr>");
    printf("<tr><td class=listr colspan=2>Connessione TCP/IP</td><td class=listbg colspan=2> <b>" . $server_ip . " : " . $server_port . " - RS485 0x%02X</b></td></tr>", $inverter_address);
    echo"<tr><td colspan=4 class=listhdrlr>Inverter</td></tr>";
    echo"<tr><td rowspan=5 width=50 align=center class=listlr><img src='./images/inverter.png'></td><td class=listr width=50%>Modello:</td><td class=listbg width=50% colspan=2><b>" . $Version . " (" . HexToChar($SN) . ")</b></td></tr>";
    printf("<tr><td class=listr>Temperatura (CPU/IGBT):</td><td class=listbg colspan=2><b>%.0fC / %.0fC</b></td></tr>",$DSP15,$DSP16);
    printf("<tr><td class=listr>R Isolamento:</td><td class=listbg colspan=2><b>%.2f MOhm</b></td></tr>", $DSP30);
    printf("<tr><td class=listr>Corrente Dispersione</td><td class=listbg colspan=2><b>%.2f mA</b></td></tr>", $DSP7);
    printf("<tr><td class=listr>Rete:</td><td class=listbg colspan=2><b>%.1fV %.1fHz</b></td></tr>", $DSP1 , $DSP4);
    echo"<tr><td colspan=4 class=listhdrlr>Stato</td></tr>";
    $globale_led="yellow.png";
    if($globale_led==6) $inverter_led="green.png"; #bug ris 0.7
    echo"<tr><td colspan=2 class=listr>Globale:</td><td class=listbg><img height=23 width=23 src=\"./images/$globale_led\"></td><td class=listbg><b>".$GlobalState_Label[$GlobalState]."</b></td></tr>";
    $inverter_led="yellow.png";
    if($InverterState==2) $inverter_led="green.png";
    echo"<tr><td colspan=2 class=listr>Inverter:</td><td class=listbg><img height=23 width=23 src=\"./images/$inverter_led\"></td><td class=listbg><b>".$InverterState_Label[$InverterState]."</b></td></tr>";
    $allarme_led="red.png";
    if($AlarmState==0) $allarme_led="grey.png";
    echo"<tr><td colspan=2 class=listr width=50%>Allarme:</td><td class=listbg><img height=23 width=23 src=\"./images/$allarme_led\"></td><td class=listbg width=50%><b>".$AlarmState_Label[$AlarmState][0]." " .$AlarmCODE . "</b></td></tr>";
    echo"<tr><td colspan=4 class=listhdrlr>Potenza</td></tr>";
    printf("<tr><td colspan=2 class=listr>Potenza di Uscita:</td><td class=listbg colspan=2><b>%.02f W</b></td></tr>", $DSP3);
    printf("<tr><td colspan=2 class=listr>Potenza di Ingresso:</td><td class=listbg colspan=2><b>%.02f W</b></td></tr>", $PIN);
    printf("<tr><td colspan=2 class=listr>Stringa 1:</td><td class=listbg colspan=2><b>%.02fW</b> (%.02fV  %.02fA)</td></tr>", $DSP8, $DSP23, $DSP25);
    printf("<tr><td colspan=2 class=listr>Stringa 2:</td><td class=listbg colspan=2><b>%.02fW</b> (%.02fV  %.02fA)</td></tr>", $DSP9, $DSP26, $DSP27);

    echo"<tr><td colspan=4 class=listhdrlr>Produzione</td></tr>";
    printf("<tr><td rowspan=2 align=center class=listlr><img src='./images/counter.png'></td><td class=listr>Produzione Totale:</td><td class=listbg colspan=2><b>%.02f KWh</b></td></tr>", $CET);
    printf("<tr><td class=listr>Produzione Giornaliera:</td><td class=listbg colspan=2><b>%.02f KWh</b></td></tr>", $CED);
    if($incentivo>0){
      echo"<tr><td colspan=4 class=listhdrlr>Incentivo (Euro/KWh: $incentivo)</td></tr>";
      printf("<tr><td rowspan=2 align=center class=listlr><img src='./images/money.png'></td><td class=listr>Stima Guadagno Totale:</td><td class=listbg colspan=2><b>%.02f </b></td></tr>", ($CET * $incentivo));
      printf("<tr><td class=listr>Stima Guadagno Giornaliero:</td><td class=listbg  colspan=2><b>%.02f </b></td></tr>", ($CED* $incentivo));
    }

  } else {
    echo"<center><table width=70% cellspacing=0 cellpadding=0 border=0>";
    echo "<tr><td align=center><br></td></tr>";
    echo "<tr><td align=center class=listbg><table width=40%>";
    
    if($res==1){
      echo"<tr><td align=center><img src=\"./images/error.png\"></td><td align=center height=100 class=listnorm nowrap>ERRORE - Connessione TCP/IP  fallita.<br>";
      echo"Indirizzo IP: " . $server_ip . " Porta TCP/IP: " . $server_port . "<br></td></tr>";
    } if($res==10) {
      echo"<tr><td align=center><img src=\"./images/check.png\"></td><td align=left height=70 class=listnorm nowrap>Connessione TCP/IP  OK.</td></tr>";
      echo"<tr><td align=center><img src=\"./images/error.png\"></td><td align=left height=70 class=listnorm nowrap>ERRORE - Comunicazione con l'inverter fallita (indirizzo $inverter_address).<br>L'inverter potrebbe essere offline</td></tr></center>";
    }
    echo "</table></td></tr>";
  }
  echo"<table>";
}
echo "<div id=pagefooter>
$_APP_NAME ver $_APP_VER<br>Dev By DeSantiX.iT<br>
</div>";
?>
<center>
<span class=listnorm ></span>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
<input type="hidden" name="cmd" value="_s-xclick">
<input type="hidden" name="hosted_button_id" value="GD6FPPMPSML9W">
<input type="image" src="https://www.paypalobjects.com/it_IT/IT/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Offrimi Un Caff">
<img alt="" border="0" src="https://www.paypalobjects.com/it_IT/i/scr/pixel.gif" width="1" height="1">
</form>

</center>
</body></html>  
